gtkmm: Gtk::EntryCompletion Class Reference

gtkmm 3.15.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::EntryCompletion Class Reference

Completion functionality for Gtk::Entry. More...

`#include <gtkmm/entrycompletion.h>`

Inheritance diagram for Gtk::EntryCompletion:
[legend]

## Public Types
typedef sigc::slot< bool, const Glib::ustring &, const TreeModel::const_iterator& > | SlotMatch
| For example, bool on_match(const Glib::ustring& key, const TreeModel::const_iterator& iter);. More...
Public Types inherited from Gtk::CellLayout
typedef sigc::slot< void, const TreeModel::const_iterator& > | SlotCellData

## Public Member Functions
virtual | ~EntryCompletion ()
GtkEntryCompletion* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEntryCompletion* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEntryCompletion* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Entry* | get_entry ()
| Gets the entry completion has been attached to. More...
const Entry* | get_entry () const
| Gets the entry completion has been attached to. More...
void | set_model (const Glib::RefPtr< TreeModel >& model)
| Sets the model for a Gtk::EntryCompletion. More...
Glib::RefPtr< TreeModel > | get_model ()
| Returns the model the Gtk::EntryCompletion is using as data source. More...
Glib::RefPtr< const TreeModel > | get_model () const
| Returns the model the Gtk::EntryCompletion is using as data source. More...
void | unset_model ()
| Remove the model from the EntryCompletion. More...
void | set_match_func (const SlotMatch& slot)
void | set_minimum_key_length (int length)
| Requires the length of the search key for completion to be at least length. More...
int | get_minimum_key_length () const
| Returns the minimum key length as set for completion. More...
Glib::ustring | compute_prefix (const Glib::ustring& key)
| Computes the common prefix that is shared by all rows in completion that start with key. More...
void | complete ()
| Requests a completion operation, or in other words a refiltering of the current list with completions, using the current key. More...
void | insert_prefix ()
| Requests a prefix insertion. More...
void | insert_action_text (const Glib::ustring& text, int index)
void | prepend_action_text (const Glib::ustring& text)
void | insert_action_markup (const Glib::ustring& markup, int index)
void | prepend_action_markup (const Glib::ustring& markup)
void | delete_action (int index=0)
| Deletes the action at index from completion’s action list. More...
void | set_inline_completion (bool inline_completion=true)
| Sets whether the common prefix of the possible completions should be automatically inserted in the entry. More...
bool | get_inline_completion () const
| Returns whether the common prefix of the possible completions should be automatically inserted in the entry. More...
void | set_inline_selection (bool inline_selection=true)
| Sets whether it is possible to cycle through the possible completions inside the entry. More...
bool | get_inline_selection () const
| Returns `true` if inline-selection mode is turned on. More...
void | set_popup_completion (bool popup_completion=true)
| Sets whether the completions should be presented in a popup window. More...
bool | get_popup_completion () const
| Returns whether the completions should be presented in a popup window. More...
void | set_popup_set_width (bool popup_set_width=true)
| Sets whether the completion popup window will be resized to be the same width as the entry. More...
bool | get_popup_set_width () const
| Returns whether the completion popup window will be resized to the width of the entry. More...
void | set_popup_single_match (bool popup_single_match=true)
| Sets whether the completion popup window will appear even if there is only a single match. More...
bool | get_popup_single_match () const
| Returns whether the completion popup window will appear even if there is only a single match. More...
Glib::ustring | get_completion_prefix () const
| Get the original text entered by the user that triggered the completion or an empty string if there's no completion ongoing. More...
void | set_text_column (const TreeModelColumnBase& column)
| Convenience function for setting up the most used case of this code: a completion list with just strings. More...
void | set_text_column (int column)
| Convenience function for setting up the most used case of this code: a completion list with just strings. More...
int | get_text_column () const
| Returns the column in the model of completion to get strings from. More...
Glib::SignalProxy1< void, int > | signal_action_activated ()
Glib::SignalProxy1< bool, const TreeModel::iterator& > | signal_match_selected ()
| Emitted when a match from the list is selected. More...
Glib::SignalProxy1< bool, const TreeModel::iterator& > | signal_cursor_on_match ()
| Emitted when a match from the cursor is on a match of the list. More...
Glib::SignalProxy1< bool, const Glib::ustring& > | signal_insert_prefix ()
Glib::SignalProxy0< void > | signal_no_matches ()
Glib::PropertyProxy < Glib::RefPtr< Gtk::TreeModel > > | property_model ()
| The model to find matches in. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gtk::TreeModel > > | property_model () const
| The model to find matches in. More...
Glib::PropertyProxy< int > | property_minimum_key_length ()
| Minimum length of the search key in order to look up matches. More...
Glib::PropertyProxy_ReadOnly< int > | property_minimum_key_length () const
| Minimum length of the search key in order to look up matches. More...
Glib::PropertyProxy< int > | property_text_column ()
| The column of the model containing the strings. More...
Glib::PropertyProxy_ReadOnly< int > | property_text_column () const
| The column of the model containing the strings. More...
Glib::PropertyProxy< bool > | property_inline_completion ()
| Whether the common prefix should be inserted automatically. More...
Glib::PropertyProxy_ReadOnly < bool > | property_inline_completion () const
| Whether the common prefix should be inserted automatically. More...
Glib::PropertyProxy< bool > | property_popup_completion ()
| Whether the completions should be shown in a popup window. More...
Glib::PropertyProxy_ReadOnly < bool > | property_popup_completion () const
| Whether the completions should be shown in a popup window. More...
Glib::PropertyProxy< bool > | property_popup_set_width ()
| If TRUE, the popup window will have the same size as the entry. More...
Glib::PropertyProxy_ReadOnly < bool > | property_popup_set_width () const
| If TRUE, the popup window will have the same size as the entry. More...
Glib::PropertyProxy< bool > | property_popup_single_match ()
| If TRUE, the popup window will appear for a single match. More...
Glib::PropertyProxy_ReadOnly < bool > | property_popup_single_match () const
| If TRUE, the popup window will appear for a single match. More...
Glib::PropertyProxy< bool > | property_inline_selection ()
| Your description here. More...
Glib::PropertyProxy_ReadOnly < bool > | property_inline_selection () const
| Your description here. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< CellArea > > | property_cell_area () const
| The GtkCellArea used to layout cells. More...
Public Member Functions inherited from Gtk::CellLayout
virtual | ~CellLayout ()
GtkCellLayout* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkCellLayout* | gobj () const
| Provides access to the underlying C GObject. More...
template<class ColumnType >
void | pack_start (const TreeModelColumn< ColumnType >& model_column, bool expand=true)
void | pack_start (CellRenderer& cell, bool expand=true)
| Packs the cell into the beginning of cell_layout. More...
void | pack_end (CellRenderer& cell, bool expand=true)
| Adds the cell to the end of cell_layout. More...
std::vector< CellRenderer* > | get_cells ()
| Return value: a list of cell renderers. More...
std::vector< const CellRenderer* > | get_cells () const
| Return value: a list of cell renderers. More...
CellRenderer* | get_first_cell ()
| Gets the CellRenderer for the column. More...
const CellRenderer* | get_first_cell () const
| Gets the CellRenderer for the column. More...
void | clear ()
| Unsets all the mappings on all renderers on cell_layout and removes all renderers from cell_layout. More...
void | add_attribute (CellRenderer& cell, const Glib::ustring& attribute, int column)
| Adds an attribute mapping to the list in cell_layout. More...
void | add_attribute (const Glib::PropertyProxy_Base& property, const TreeModelColumnBase& column)
void | add_attribute (CellRenderer& cell, const Glib::ustring& attribute, const TreeModelColumnBase& column)
void | set_cell_data_func (CellRenderer& cell, const SlotCellData& slot)
void | clear_attributes (CellRenderer& cell)
| Clears all existing attributes previously set with set_attributes(). More...
void | reorder (CellRenderer& cell, int position)
| Re-inserts cell at position. More...
Glib::RefPtr< CellArea > | get_area ()
| Returns the underlying Gtk::CellArea which might be cell_layout if called on a Gtk::CellArea or might be `0` if no Gtk::CellArea is used by cell_layout. More...
Glib::RefPtr< const CellArea > | get_area () const
| Returns the underlying Gtk::CellArea which might be cell_layout if called on a Gtk::CellArea or might be `0` if no Gtk::CellArea is used by cell_layout. More...
template<class T_ModelColumnType >
void | pack_start (const TreeModelColumn< T_ModelColumnType >& column, bool expand)
Public Member Functions inherited from Gtk::Buildable
virtual | ~Buildable ()
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_name (const Glib::ustring& name)
| Sets the name of the buildable object. More...
Glib::ustring | get_name () const
| Gets the name of the buildable object. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr < EntryCompletion > | create ()
Static Public Member Functions inherited from Gtk::CellLayout
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| EntryCompletion ()
virtual bool | on_match_selected (const TreeModel::iterator& iter)
virtual void | on_action_activated (int index)
| This is a default handler for the signal signal_action_activated(). More...
virtual bool | on_insert_prefix (const Glib::ustring& prefix)
| This is a default handler for the signal signal_insert_prefix(). More...
Protected Member Functions inherited from Gtk::CellLayout
| CellLayout ()
| You should derive from this class to use it. More...
virtual void | pack_start_vfunc (CellRenderer* cell, bool expand)
virtual void | pack_end_vfunc (CellRenderer* cell, bool expand)
virtual void | clear_vfunc ()
virtual void | add_attribute_vfunc (CellRenderer* cell, const Glib::ustring& attribute, int column)
virtual void | clear_attributes_vfunc (CellRenderer* cell)
virtual void | reorder_vfunc (CellRenderer* cell, int position)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gtk::EntryCompletion > | wrap (GtkEntryCompletion* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::CellLayout
Glib::RefPtr< Gtk::CellLayout > | wrap (GtkCellLayout* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Completion functionality for Gtk::Entry.

Gtk::EntryCompletion is an auxiliary object to be used in conjunction with Gtk::Entry to provide the completion functionality.

It derives from Gtk::CellLayout, to allow the user to add extra cells to the Gtk::TreeView with completion matches.

"Completion functionality" means that when the user modifies the text in the entry, Gtk::EntryCompletion checks which rows in the model match the current content of the entry, and displays a list of matches. By default, the matching is done by comparing the entry text case-insensitively against the text column of the model (see set_text_column()), but this can be overridden with a custom match function (see set_match_func()).

When the user selects a completion, the content of the entry is updated. By default, the content of the entry is replaced by the text column of the model, but this can be overridden by connecting to the match_selected signal and updating the entry in the signal handler. Note that you should return true from the signal handler to suppress the default behaviour.

To add completion functionality to an entry, use Gtk::Entry::set_completion().

In addition to regular completion matches, which will be inserted into the entry when they are selected, Gtk::EntryCompletion also allows the display of "actions" in the popup window. Their appearance is similar to menu items, to differentiate them clearly from completion strings. When an action is selected, the action_activated signal is emitted.

## Member Typedef Documentation

typedef sigc::slot<bool, const Glib::ustring&, const TreeModel::const_iterator&> Gtk::EntryCompletion::SlotMatch

For example, bool on_match(const Glib::ustring& key, const TreeModel::const_iterator& iter);.

## Constructor & Destructor Documentation

virtual Gtk::EntryCompletion::~EntryCompletion | ( |  | ) |
| virtual

Gtk::EntryCompletion::EntryCompletion | ( |  | ) |
| protected

## Member Function Documentation

void Gtk::EntryCompletion::complete | ( |  | ) |

Requests a completion operation, or in other words a refiltering of the current list with completions, using the current key.

The completion list view will be updated accordingly.

Since gtkmm 2.4:

Glib::ustring Gtk::EntryCompletion::compute_prefix | ( | const Glib::ustring & | key | ) |

Computes the common prefix that is shared by all rows in completion that start with key.

If no row matches key, `0` will be returned. Note that a text column must have been set for this function to work, see set_text_column() for details.

Since gtkmm 3.4:

Parameters

  key | The text to complete for.

Returns
  The common prefix all rows starting with key or `0` if no row matches key.

static Glib::RefPtr<EntryCompletion> Gtk::EntryCompletion::create | ( |  | ) |
| static

void Gtk::EntryCompletion::delete_action | ( | int | index = `0` | ) |

Deletes the action at index from completion’s action list.

Since gtkmm 2.4:

Parameters

  index | The index of the item to delete.

Glib::ustring Gtk::EntryCompletion::get_completion_prefix | ( |  | ) | const

Get the original text entered by the user that triggered the completion or an empty string if there's no completion ongoing.

Since gtkmm 2.12:

Returns
  The prefix for the current completion.

Entry* Gtk::EntryCompletion::get_entry | ( |  | ) |

Gets the entry completion has been attached to.

Since gtkmm 2.4:

Returns
  The entry completion has been attached to.

const Entry* Gtk::EntryCompletion::get_entry | ( |  | ) | const

Gets the entry completion has been attached to.

Since gtkmm 2.4:

Returns
  The entry completion has been attached to.

bool Gtk::EntryCompletion::get_inline_completion | ( |  | ) | const

Returns whether the common prefix of the possible completions should be automatically inserted in the entry.

Since gtkmm 2.6:

Returns
  `true` if inline completion is turned on.

bool Gtk::EntryCompletion::get_inline_selection | ( |  | ) | const

Returns `true` if inline-selection mode is turned on.

Since gtkmm 2.12:

Returns
  `true` if inline-selection mode is on.

int Gtk::EntryCompletion::get_minimum_key_length | ( |  | ) | const

Returns the minimum key length as set for completion.

Since gtkmm 2.4:

Returns
  The currently used minimum key length.

Glib::RefPtr<TreeModel> Gtk::EntryCompletion::get_model | ( |  | ) |

Returns the model the Gtk::EntryCompletion is using as data source.

Returns `0` if the model is unset.

Since gtkmm 2.4:

Returns
  A Gtk::TreeModel, or `0` if none is currently being used.

Glib::RefPtr<const TreeModel> Gtk::EntryCompletion::get_model | ( |  | ) | const

Returns the model the Gtk::EntryCompletion is using as data source.

Returns `0` if the model is unset.

Since gtkmm 2.4:

Returns
  A Gtk::TreeModel, or `0` if none is currently being used.

bool Gtk::EntryCompletion::get_popup_completion | ( |  | ) | const

Returns whether the completions should be presented in a popup window.

Since gtkmm 2.6:

Returns
  `true` if popup completion is turned on.

bool Gtk::EntryCompletion::get_popup_set_width | ( |  | ) | const

Returns whether the completion popup window will be resized to the width of the entry.

Since gtkmm 2.8:

Returns
  `true` if the popup window will be resized to the width of the entry.

bool Gtk::EntryCompletion::get_popup_single_match | ( |  | ) | const

Returns whether the completion popup window will appear even if there is only a single match.

Since gtkmm 2.8:

Returns
  `true` if the popup window will appear regardless of the number of matches.

int Gtk::EntryCompletion::get_text_column | ( |  | ) | const

Returns the column in the model of completion to get strings from.

Since gtkmm 2.6:

Returns
  The column containing the strings.

static GType Gtk::EntryCompletion::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkEntryCompletion* Gtk::EntryCompletion::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkEntryCompletion* Gtk::EntryCompletion::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkEntryCompletion* Gtk::EntryCompletion::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gtk::EntryCompletion::insert_action_markup | ( | const Glib::ustring & | markup,
|  | int | index
| ) |  |

void Gtk::EntryCompletion::insert_action_text | ( | const Glib::ustring & | text,
|  | int | index
| ) |  |

void Gtk::EntryCompletion::insert_prefix | ( |  | ) |

Requests a prefix insertion.

Since gtkmm 2.6:

virtual void Gtk::EntryCompletion::on_action_activated | ( | int | index | ) |
| protectedvirtual

This is a default handler for the signal signal_action_activated().

virtual bool Gtk::EntryCompletion::on_insert_prefix | ( | const Glib::ustring & | prefix | ) |
| protectedvirtual

This is a default handler for the signal signal_insert_prefix().

virtual bool Gtk::EntryCompletion::on_match_selected | ( | const TreeModel::iterator& | iter | ) |
| protectedvirtual

void Gtk::EntryCompletion::prepend_action_markup | ( | const Glib::ustring & | markup | ) |

void Gtk::EntryCompletion::prepend_action_text | ( | const Glib::ustring & | text | ) |

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<CellArea> > Gtk::EntryCompletion::property_cell_area | ( |  | ) | const

The GtkCellArea used to layout cells.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_inline_completion | ( |  | ) |

Whether the common prefix should be inserted automatically.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_inline_completion | ( |  | ) | const

Whether the common prefix should be inserted automatically.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_inline_selection | ( |  | ) |

Your description here.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_inline_selection | ( |  | ) | const

Your description here.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::EntryCompletion::property_minimum_key_length | ( |  | ) |

Minimum length of the search key in order to look up matches.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::EntryCompletion::property_minimum_key_length | ( |  | ) | const

Minimum length of the search key in order to look up matches.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<Gtk::TreeModel> > Gtk::EntryCompletion::property_model | ( |  | ) |

The model to find matches in.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gtk::TreeModel> > Gtk::EntryCompletion::property_model | ( |  | ) | const

The model to find matches in.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_popup_completion | ( |  | ) |

Whether the completions should be shown in a popup window.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_popup_completion | ( |  | ) | const

Whether the completions should be shown in a popup window.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_popup_set_width | ( |  | ) |

If TRUE, the popup window will have the same size as the entry.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_popup_set_width | ( |  | ) | const

If TRUE, the popup window will have the same size as the entry.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_popup_single_match | ( |  | ) |

If TRUE, the popup window will appear for a single match.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_popup_single_match | ( |  | ) | const

If TRUE, the popup window will appear for a single match.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::EntryCompletion::property_text_column | ( |  | ) |

The column of the model containing the strings.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::EntryCompletion::property_text_column | ( |  | ) | const

The column of the model containing the strings.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::EntryCompletion::set_inline_completion | ( | bool | inline_completion = `true` | ) |

Sets whether the common prefix of the possible completions should be automatically inserted in the entry.

Since gtkmm 2.6:

Parameters

  inline_completion | `true` to do inline completion.

void Gtk::EntryCompletion::set_inline_selection | ( | bool | inline_selection = `true` | ) |

Sets whether it is possible to cycle through the possible completions inside the entry.

Since gtkmm 2.12:

Parameters

  inline_selection | `true` to do inline selection.

void Gtk::EntryCompletion::set_match_func | ( | const SlotMatch& | slot | ) |

void Gtk::EntryCompletion::set_minimum_key_length | ( | int | length | ) |

Requires the length of the search key for completion to be at least length.

This is useful for long lists, where completing using a small key takes a lot of time and will come up with meaningless results anyway (ie, a too large dataset).

Since gtkmm 2.4:

Parameters

  length | The minimum length of the key in order to start completing.

void Gtk::EntryCompletion::set_model | ( | const Glib::RefPtr< TreeModel >& | model | ) |

Sets the model for a Gtk::EntryCompletion.

If completion already has a model set, it will remove it before setting the new model. Use unset_model() to unset the old model.

Since gtkmm 2.4:

Parameters

  model | The Gtk::TreeModel.

void Gtk::EntryCompletion::set_popup_completion | ( | bool | popup_completion = `true` | ) |

Sets whether the completions should be presented in a popup window.

Since gtkmm 2.6:

Parameters

  popup_completion | `true` to do popup completion.

void Gtk::EntryCompletion::set_popup_set_width | ( | bool | popup_set_width = `true` | ) |

Sets whether the completion popup window will be resized to be the same width as the entry.

Since gtkmm 2.8:

Parameters

  popup_set_width | `true` to make the width of the popup the same as the entry.

void Gtk::EntryCompletion::set_popup_single_match | ( | bool | popup_single_match = `true` | ) |

Sets whether the completion popup window will appear even if there is only a single match.

You may want to set this to `false` if you are using [inline completion][GtkEntryCompletion–inline-completion].

Since gtkmm 2.8:

Parameters

  popup_single_match | `true` if the popup should appear even for a single match.

void Gtk::EntryCompletion::set_text_column | ( | const TreeModelColumnBase& | column | ) |

Convenience function for setting up the most used case of this code: a completion list with just strings.

This function will set up completion to have a list displaying all (and just) strings in the completion list, and to get those strings from column in the model of completion.

This functions creates and adds a Gtk::CellRendererText for the selected column. If you need to set the text column, but don't want the cell renderer, use Glib::object_set() to set the Gtk::EntryCompletion::property_text_column() property directly.

Since gtkmm 2.4:

Parameters

  column | The column in the model of completion to get strings from.

void Gtk::EntryCompletion::set_text_column | ( | int | column | ) |

Convenience function for setting up the most used case of this code: a completion list with just strings.

This function will set up completion to have a list displaying all (and just) strings in the completion list, and to get those strings from column in the model of completion.

This functions creates and adds a Gtk::CellRendererText for the selected column. If you need to set the text column, but don't want the cell renderer, use Glib::object_set() to set the Gtk::EntryCompletion::property_text_column() property directly.

Since gtkmm 2.4:

Parameters

  column | The column in the model of completion to get strings from.

Glib::SignalProxy1< void,int > Gtk::EntryCompletion::signal_action_activated | ( |  | ) |

Slot Prototype:
  `void on_my_action_activated(int index)`

Gets emitted when an action is activated.

Since gtkmm 2.4:

Parameters

  index | The index of the activated action.

Glib::SignalProxy1< bool, const TreeModel::iterator& > Gtk::EntryCompletion::signal_cursor_on_match | ( |  | ) |

Emitted when a match from the cursor is on a match of the list.

The default behaviour is to replace the contents of the entry with the contents of the text column in the row pointed to by iter.

Parameters

  model | The TreeModel containing the matches
  iter | A TreeModel::iterator positioned at the selected match

Returns
  true if the signal has been handled

Prototype:
  `bool on_cursor_on_match(const TreeModel::iterator& iter)`

Since gtkmm 2.12:

Glib::SignalProxy1< bool,const Glib::ustring& > Gtk::EntryCompletion::signal_insert_prefix | ( |  | ) |

Slot Prototype:
  `bool on_my_insert_prefix(const Glib::ustring& prefix)`

Gets emitted when the inline autocompletion is triggered. The default behaviour is to make the entry display the whole prefix and select the newly inserted part.

Applications may connect to this signal in order to insert only a smaller part of the prefix into the entry - e.g. the entry used in the Gtk::FileChooser inserts only the part of the prefix up to the next '/'.

Since gtkmm 2.6:

Parameters

  prefix | The common prefix of all possible completions.

Returns
  `true` if the signal has been handled.

Glib::SignalProxy1< bool, const TreeModel::iterator& > Gtk::EntryCompletion::signal_match_selected | ( |  | ) |

Emitted when a match from the list is selected.

The default behaviour is to replace the contents of the entry with the contents of the text column in the row pointed to by iter.

It is necessary to connect your signal handler before the default one, which would otherwise return `true`, a value which signifies that the signal has been handled, thus preventing any other handler from being invoked.

To do this, pass `false` to this signal proxy's `connect()` method. For example: `completion->signal_match_selected().connect(sigc::mem_fun(* this,& YourClass::on_completion_match_selected), false);`

Parameters

  model | The TreeModel containing the matches
  iter | A TreeModel::iterator positioned at the selected match

Returns
  true if the signal has been handled

Prototype:
  `bool on_match_selected(const TreeModel::iterator& iter)`

Glib::SignalProxy0< void > Gtk::EntryCompletion::signal_no_matches | ( |  | ) |

Slot Prototype:
  `void on_my_no_matches()`

Gets emitted when the filter model has zero number of rows in completion_complete method. (In other words when GtkEntryCompletion is out of suggestions)

Since gtkmm 3.14:

void Gtk::EntryCompletion::unset_model | ( |  | ) |

Remove the model from the EntryCompletion.

See also
  set_model().

Since gtkmm 2.16:

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::EntryCompletion > wrap | ( | GtkEntryCompletion * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.